<template>
  <background class="row justify-center">
    <q-card class="col-lg-10 col-md-10 col-sm-12 col-xs-12">
      <q-timeline
        color="secondary"
        layout="loose"
      >
        <q-timeline-entry heading>
          Jízdní řády
        </q-timeline-entry>

        <q-timeline-entry
          v-for="(planner, index) in plannerAll"
          :key="planner.id"
          :subtitle="dateToStr(planner.once, 'PPPPp')"
          :color="index % 2 == 0 ? 'accent': 'secondary'"
        >
          <template #title>
            {{ planner.timetable.name }}
            <q-btn
              outline
              color="primary"
              label="detail"
              size="xs"
              @click="plannerDetailClick(planner.id)"
            />
          </template>

          <div
            v-if="planner.time !== null"
            class="planner-timeline-accent"
          >
            pravidelně
          </div>
          <div
            v-else
            class="planner-timeline-secondary"
          >
            jednou
          </div>
          <div
            v-for="journey in planner.timetable.journey"
            :key="journey.id"
          >
            {{ journey.train.name }} z
            {{ journey.stationFrom.name }} do
            {{ journey.stationTo.name }}
          </div>
        </q-timeline-entry>
      </q-timeline>

      <q-select
        v-model="period"
        filled
        label="Zobrazit do"
        :options="periodOptions"
      >
        <template #append>
          <q-btn
            round
            dense
            flat
            icon="event"
            @click.stop
          >
            <q-popup-proxy
              transition-show="scale"
              transition-hide="scale"
            >
              <q-date
                v-model="range"
                range
              >
                <div class="row items-center justify-end q-gutter-sm">
                  <q-btn
                    v-close-popup
                    label="Zrušit"
                    color="primary"
                    flat
                  />
                  <q-btn
                    v-close-popup
                    label="OK"
                    color="primary"
                    flat
                    @click="setRange"
                  />
                </div>
              </q-date>
            </q-popup-proxy>
          </q-btn>
        </template>
      </q-select>
    </q-card>

    <q-page-sticky
      v-if="user.canCrudTimetable"
      position="bottom-right"
      :offset="[18, 18]"
    >
      <q-btn
        fab
        icon="edit"
        color="secondary"
        :to="{name: 'adminTimetable'}"
      />
    </q-page-sticky>
  </background>
</template>

<script lang="ts">

import { ref } from '@vue/reactivity'
import { onMounted, watch } from '@vue/runtime-core'
import { endOfDay, endOfMonth, endOfToday, endOfTomorrow, endOfWeek, parse } from 'date-fns'
import { scroll, useQuasar } from 'quasar'
import { PlannerModel } from 'web_trains_types'

import background from '@/components/Background.vue'
import PlannerAddDialog from '@/components/Timetable/PlannerAddDialog.vue'
import { dateToStr } from '@/helper/dateTime'
import { SelectOption } from '@/helper/select'
import { plannerService } from '@/service'
import useUserStore from '@/store/userStore'

enum periodValue {
  day1,
  day2,
  week,
  month
}

const periodOptions = [
  {
    label: 'dnes',
    value: periodValue.day1
  },
  {
    label: 'zítra',
    value: periodValue.day2
  },
  {
    label: 'týden',
    value: periodValue.week
  },
  {
    label: 'měsíc',
    value: periodValue.month
  }
]

export default {
  name: 'Planner',
  components: {
    background
  },
  setup (): any {
    const user = useUserStore()
    const $q = useQuasar()

    const plannerAll = ref<PlannerModel[]>()
    const period = ref<SelectOption>(periodOptions[0])
    const range = ref<{from: string, to: string}>()

    const scrollTop = () => {
      const ele = document.getElementById('back-home-anim')

      if (!ele) {
        return
      }

      const offset = ele.offsetTop - ele.scrollHeight
      const duration = 1000

      const target = scroll.getScrollTarget(ele)
      scroll.setVerticalScrollPosition(target, offset, duration)
    }

    const loadData = (from: Date, to: Date) => {
      $q.loading.show()

      plannerService.getRange(from, to)
        .then((result) => {
          plannerAll.value = result
          scrollTop()
        })
        .finally(() => {
          $q.loading.hide()
        })
    }

    const now = new Date()

    watch(period, (val) => {
      switch (val?.value) {
        case periodValue.day1:
          loadData(now, endOfToday())
          break
        case periodValue.day2:
          loadData(now, endOfTomorrow())
          break
        case periodValue.week:
          loadData(now, endOfWeek(now))
          break
        case periodValue.month:
          loadData(now, endOfMonth(now))
          break
      }
    })

    const setRange = () => {
      if (range.value === undefined) {
        return
      }

      const from = parse(range.value.from, 'yyyy/MM/dd', new Date(0, 0, 0, 0, 0, 0, 0))
      const to = endOfDay(parse(range.value.to, 'yyyy/MM/dd', new Date(0, 0, 0, 0, 0, 0, 0)))

      loadData(from, to)

      period.value = {
        label: dateToStr(from, 'P') + ' - ' + dateToStr(to, 'P'),
        value: -1
      }
    }

    onMounted(() => {
      loadData(new Date(), endOfToday())
    })

    const plannerDetailClick = (id:number) => {
      $q.dialog({
        component: PlannerAddDialog,
        componentProps: {
          id: id,
          detail: true
        }
      })
    }

    return {
      user,
      plannerAll,
      dateToStr,
      period,
      periodOptions,
      range,
      setRange,
      plannerDetailClick
    }
  }
}

</script>
